with(DETools):
Wrapper := proc(P, A)
	global x, Dx, xDx, `DEtools/diffop/x`,`DEtools/diffop/DF`, `DEtools/diffop/xDF`;
	local R;
	R := eval(A, {x=`DEtools/diffop/x`, Dx=`DEtools/diffop/DF`, xDx=`DEtools/diffop/xDF`});
	R := P(op(R));
	eval(R, {`DEtools/diffop/x` = x,`DEtools/diffop/DF` = Dx, `DEtools/diffop/xDF` = xDx})
end:

macro(
	eval_laurent=`DEtools/diffop/eval_laurent`,
	nt=`DEtools/diffop/nt`,
	factor_op=`DEtools/diffop/factor_op`,
	l_p=`DEtools/diffop/l_p`
):

_Envdiffopdomain := [Dx,x]:

# Here xDx represents x*Dx

L1 :=-xDx^175 - xDx^174 - 2*xDx^173 + xDx^172 - 23*xDx^170 - xDx^169 + xDx^168 + 7*xDx^167 - xDx^166 + xDx^165 + xDx^164 - xDx^163 + 4*xDx^162 - 364*xDx^161 + 15*xDx^160 - xDx^159 - 30*xDx^158 - xDx^156 - xDx^155 + xDx^154 + xDx^153 + 2*xDx^151 + xDx^150 - 20*xDx^148 - 7*xDx^147 + xDx^145 - xDx^144 - 2*xDx^143 - 2*xDx^142 - xDx^141 + 11*xDx^140 + xDx^139 - 6*xDx^138 + xDx^136 - xDx^135 + xDx^134 - 3*xDx^133 + xDx^132 + xDx^131 - 4*xDx^129 - 2*xDx^128 - xDx^127 - 6*xDx^126 - 6*xDx^125 - 15*xDx^124 - xDx^123 - 2*xDx^120 + xDx^118 + xDx^117 + xDx^116 - xDx^115 - 7*xDx^114 - 11*xDx^113 - 4*xDx^112 + xDx^111 + xDx^110 - xDx^108 - xDx^107 + xDx^106 + xDx^105 - xDx^103 - xDx^102 + 2*xDx^101 - xDx^100 + 2*xDx^99 + xDx^98 - 5*xDx^96 - 3*xDx^95 + 2*xDx^94 + xDx^93 + 16*xDx^92 + 6*xDx^91 + xDx^90 - xDx^89 + 59*xDx^88 + 13*xDx^87 + xDx^86 + 6*xDx^85 - xDx^84 - 9*xDx^82 + 10*xDx^78 - 2*xDx^77 - xDx^74 - 2*xDx^71 - xDx^70 - xDx^68 + xDx^67 - 40*xDx^66 + xDx^65 - xDx^63 + xDx^62 - xDx^61 + xDx^60 + xDx^59 - xDx^58 - xDx^57 + 7*xDx^56 + xDx^55 - 2*xDx^54 + 2*xDx^52 - 9*xDx^51 - 5*xDx^50 + 2*xDx^48 - 15*xDx^45 - 2*xDx^43 + 6*xDx^42 - 6*xDx^39 - xDx^38 + 5*xDx^37 + 4*xDx^36 - 26*xDx^35 + xDx^34 + 20*xDx^33 - 4*xDx^32 + 7*xDx^31 - 8*xDx^29 + 2*xDx^28 - xDx^27 - xDx^26 - xDx^24 + 3*xDx^23 - 6*xDx^22 + 3*xDx^21 - xDx^20 + xDx^19 - 2*xDx^16 + xDx^14 + xDx^13 + xDx^12 + xDx^11 + xDx^10 - 4*xDx^9 + 2*xDx^8 + 2*xDx^7 + 2*xDx^6 + 2*xDx^3 + 2*xDx^2 - xDx + 1;

L2 := 3*xDx^175 + 2*xDx^174 + 3*xDx^172 + 2*xDx^171 + xDx^170 - 22*xDx^169 - 2*xDx^168 - 65*xDx^165 + xDx^164 + xDx^162 - 4*xDx^161 + 2*xDx^160 - 5*xDx^158 + xDx^157 - xDx^155 - xDx^154 + 2*xDx^153 + xDx^151 + xDx^150 - xDx^148 - xDx^145 - 2*xDx^143 + xDx^141 - xDx^140 + xDx^138 + xDx^137 + xDx^136 + 60*xDx^135 + 37*xDx^134 + 17*xDx^133 - 3*xDx^132 + xDx^131 - 5*xDx^130 - xDx^128 + xDx^127 - xDx^126 + xDx^125 + 3*xDx^124 + xDx^123 + 2*xDx^122 + 3*xDx^121 + 9*xDx^120 - xDx^119 + 4*xDx^118 + 2*xDx^117 - 2*xDx^116 - xDx^115 + xDx^114 - xDx^113 + xDx^112 - xDx^111 + 2*xDx^110 - 3*xDx^109 - xDx^108 - xDx^107 + 60*xDx^106 - 4*xDx^105 + 3*xDx^99 + 9*xDx^98 - 33*xDx^97 - 2*xDx^95 - xDx^94 - 4*xDx^93 - xDx^92 - 3*xDx^91 - 2*xDx^88 + xDx^87 + 3*xDx^86 + 6*xDx^85 - xDx^84 - xDx^83 + xDx^81 + xDx^80 - xDx^79 - xDx^78 + xDx^77 - xDx^75 + xDx^74 + xDx^73 - xDx^72 - xDx^71 + xDx^70 + xDx^69 - xDx^68 - 2*xDx^67 - 2*xDx^65 - 8*xDx^63 + xDx^62 + xDx^60 + xDx^58 + 9*xDx^57 - 7*xDx^56 + xDx^55 - 4*xDx^54 + 63*xDx^53 - xDx^52 + 2*xDx^51 - 3*xDx^50 - 2*xDx^49 - 7*xDx^47 - 2*xDx^46 + 2*xDx^45 + xDx^44 - xDx^42 + xDx^41 - xDx^39 - xDx^38 - 11*xDx^37 - xDx^36 + 8*xDx^35 - 3*xDx^34 + xDx^32 + 2*xDx^31 + 6*xDx^30 - xDx^29 - xDx^28 - 19*xDx^27 + 2*xDx^26 + 2*xDx^23 + xDx^21 - 2*xDx^20 + 3*xDx^19 + xDx^18 + xDx^17 - 2*xDx^16 - xDx^15 + xDx^14 + xDx^13 + xDx^12 - xDx^9 + 3*xDx^8 + xDx^7 + 2*xDx^6 + xDx^5 + 3*xDx^4 - 5*xDx^3 - xDx^2 - xDx - 6 ;

L1_Dx_notation := add( coeff(L1,xDx,i) * mult( (x*Dx)$i ), i = 0..degree(L1, xDx)):
L2_Dx_notation := add( coeff(L2,xDx,i) * mult( (x*Dx)$i ), i = 0..degree(L1, xDx)):
L1L2 := mult(L1_Dx_notation,L2_Dx_notation);

#Start_Time := time();

Linput := Wrapper(l_p, [L1L2,0]);
V := Wrapper(factor_op, [Linput, `all right factors`]);
# Now V contains a list of right-hand factors in Q[[x]][xDx]
# stored in an internal format.  We need another program to read off terms.

Try1 := Wrapper(nt, [ V[1], 3] );
Try2 := Wrapper(nt, [ V[2], 3] );

# One of these Try's has large coefficients,  while the other gives the
# right-hand factor L2 reduced mod x^3.
# Lets compute some more terms for that one.

if length(Try1) < length(Try2) then
	R := Wrapper(nt, [ V[1], 18] )
else
	R := Wrapper(nt, [ V[2], 18] )
fi;

normal(L2/R);

# As you can see,  Maple's internal factor_op command (combined with nt)
# factored the operator L in half a second.

# In the rational Weyl algebra, factoring this operator of order 20 would
# have been quite time consuming.  But in the polynomial Weyl algebra,
# factoring is generally much faster.  Of course, this is just one example,
# one could consider different types of examples, but when comparing
# algorithms on examples and CPU times, one could include this example.

#time() - Start_Time;
