with(DETools):
Wrapper := proc(P, A)
	global x, Dx, xDx, `DEtools/diffop/x`,`DEtools/diffop/DF`, `DEtools/diffop/xDF`;
	local R;
	R := eval(A, {x=`DEtools/diffop/x`, Dx=`DEtools/diffop/DF`, xDx=`DEtools/diffop/xDF`});
	R := P(op(R));
	eval(R, {`DEtools/diffop/x` = x,`DEtools/diffop/DF` = Dx, `DEtools/diffop/xDF` = xDx})
end:

macro(
	eval_laurent=`DEtools/diffop/eval_laurent`,
	nt=`DEtools/diffop/nt`,
	factor_op=`DEtools/diffop/factor_op`,
	l_p=`DEtools/diffop/l_p`
):

_Envdiffopdomain := [Dx,x]:

# Here xDx represents x*Dx

L1 := -x*xDx^50 + 2*x*xDx^49 + 6*x*xDx^48 + x*xDx^47 + x*xDx^46 + 74*x*xDx^45 + x*xDx^44 + 14*x*xDx^43 - x*xDx^42 - 9*x*xDx^41 + x*xDx^40 + x*xDx^38 - 2*x*xDx^37 + 3*x*xDx^35 + x*xDx^34 - x*xDx^33 - 5*x*xDx^32 + 3*x*xDx^31 - 2*x*xDx^30 - 7*x*xDx^29 - 3*x*xDx^28 + x*xDx^27 + x*xDx^26 + x*xDx^25 + 9*x*xDx^24 - 2*x*xDx^23 + 6*x*xDx^22 - 2*x*xDx^21 + 10*x*xDx^19 - x*xDx^18 - x*xDx^17 - 10*x*xDx^16 + x*xDx^15 + x*xDx^14 - 5*x*xDx^12 + x*xDx^11 + x*xDx^10 - x*xDx^7 - 2*x*xDx^6 + x*xDx^4 + x*xDx^3 - x*xDx^2 + 8*x*xDx - 4*x;

L2 := -9*x*xDx^50 - 7*x*xDx^49 + 33*x*xDx^48 - x*xDx^47 - x*xDx^46 + 108*x*xDx^45 + 6*x*xDx^44 + 3*x*xDx^43 + x*xDx^42 - 6*x*xDx^41 - x*xDx^40 - x*xDx^39 + x*xDx^38 + 2*x*xDx^37 - x*xDx^36 - x*xDx^35 + 2*x*xDx^34 + x*xDx^33 + x*xDx^32 - 2*x*xDx^31 - x*xDx^30 - 2*x*xDx^29 + 2*x*xDx^28 - x*xDx^27 + 3*x*xDx^26 + 2*x*xDx^25 + x*xDx^24 + 2*x*xDx^23 - 36*x*xDx^22 + 2*x*xDx^21 + x*xDx^20 + x*xDx^19 + x*xDx^18 + 2*x*xDx^17 + 2*x*xDx^16 - x*xDx^15 - x*xDx^14 + x*xDx^13 + 4*x*xDx^12 - x*xDx^11 + 3*x*xDx^8 - x*xDx^6 + x*xDx^5 + 2*x*xDx^4 + x*xDx^3 + x*xDx^2 - 5*x*xDx - x;

L1_Dx_notation := add( coeff(L1,xDx,i) * mult( (x*Dx)$i ), i = 0..degree(L1, xDx)):
L2_Dx_notation := add( coeff(L2,xDx,i) * mult( (x*Dx)$i ), i = 0..degree(L1, xDx)):
L1L2 := mult(L1_Dx_notation,L2_Dx_notation);

#Start_Time := time();

Linput := Wrapper(l_p, [L1L2,0]);
V := Wrapper(factor_op, [Linput, `all right factors`]);
# Now V contains a list of right-hand factors in Q[[x]][xDx]
# stored in an internal format.  We need another program to read off terms.

Try1 := Wrapper(nt, [ V[1], 3] );
Try2 := Wrapper(nt, [ V[2], 3] );

# One of these Try's has large coefficients,  while the other gives the
# right-hand factor L2 reduced mod x^3.
# Lets compute some more terms for that one.

if length(Try1) < length(Try2) then
	R := Wrapper(nt, [ V[1], 2] )
else
	R := Wrapper(nt, [ V[2], 2] )
fi;

normal(L2/R);

# As you can see,  Maple's internal factor_op command (combined with nt)
# factored the operator L in half a second.

# In the rational Weyl algebra, factoring this operator of order 20 would
# have been quite time consuming.  But in the polynomial Weyl algebra,
# factoring is generally much faster.  Of course, this is just one example,
# one could consider different types of examples, but when comparing
# algorithms on examples and CPU times, one could include this example.

#time() - Start_Time;
