with(DETools):
Wrapper := proc(P, A)
	global x, Dx, xDx, `DEtools/diffop/x`,`DEtools/diffop/DF`, `DEtools/diffop/xDF`;
	local R;
	R := eval(A, {x=`DEtools/diffop/x`, Dx=`DEtools/diffop/DF`, xDx=`DEtools/diffop/xDF`});
	R := P(op(R));
	eval(R, {`DEtools/diffop/x` = x,`DEtools/diffop/DF` = Dx, `DEtools/diffop/xDF` = xDx})
end:

macro(
	eval_laurent=`DEtools/diffop/eval_laurent`,
	nt=`DEtools/diffop/nt`,
	factor_op=`DEtools/diffop/factor_op`,
	l_p=`DEtools/diffop/l_p`
):

_Envdiffopdomain := [Dx,x]:

# Here xDx represents x*Dx

L1:=-x^3*xDx^10 + x^3*xDx^9 - 2*x^3*xDx^8 - 2*x^3*xDx^7 - 2*x^3*xDx^6 - x^3*xDx^5 - x^3*xDx^4 + 13*x^3*xDx^3 + 9*x^3*xDx - x^3*7;

L2:=x^3*xDx^10 + x^3*xDx^9 - x^3*xDx^8 - x^3*xDx^6 + 9*x^3*xDx^5 + x^3*xDx^4 + 3*x^3*xDx^3 - x^3*xDx^2 - 26*x^3*xDx + x^3*2;

L1_Dx_notation := add( coeff(L1,xDx,i) * mult( (x*Dx)$i ), i = 0..degree(L1, xDx)):
L2_Dx_notation := add( coeff(L2,xDx,i) * mult( (x*Dx)$i ), i = 0..degree(L1, xDx)):
L1L2 := mult(L1_Dx_notation, L2_Dx_notation);

#Start_Time := time();

Linput := Wrapper(l_p, [L1L2,0]);
V := Wrapper(factor_op, [Linput, `all right factors`]);
# Now V contains a list of right-hand factors in Q[[x]][xDx]
# stored in an internal format.  We need another program to read off terms.

Try1 := Wrapper(nt, [ V[1], 3] );
Try2 := Wrapper(nt, [ V[2], 3] );

# One of these Try's has large coefficients,  while the other gives the
# right-hand factor L2 reduced mod x^3.
# Lets compute some more terms for that one.

if length(Try1) < length(Try2) then
	R := Wrapper(nt, [ V[1], 4] )
else
	R := Wrapper(nt, [ V[2], 4] )
fi;

normal(L2/R);

# As you can see,  Maple's internal factor_op command (combined with nt)
# factored the operator L in half a second.

# In the rational Weyl algebra, factoring this operator of order 20 would
# have been quite time consuming.  But in the polynomial Weyl algebra,
# factoring is generally much faster.  Of course, this is just one example,
# one could consider different types of examples, but when comparing
# algorithms on examples and CPU times, one could include this example.

#time() - Start_Time;
