with(DETools):
Wrapper := proc(P, A)
	global x, Dx, xDx, `DEtools/diffop/x`,`DEtools/diffop/DF`, `DEtools/diffop/xDF`;
	local R;
	R := eval(A, {x=`DEtools/diffop/x`, Dx=`DEtools/diffop/DF`, xDx=`DEtools/diffop/xDF`});
	R := P(op(R));
	eval(R, {`DEtools/diffop/x` = x,`DEtools/diffop/DF` = Dx, `DEtools/diffop/xDF` = xDx})
end:

macro(
	eval_laurent=`DEtools/diffop/eval_laurent`,
	nt=`DEtools/diffop/nt`,
	factor_op=`DEtools/diffop/factor_op`,
	l_p=`DEtools/diffop/l_p`
):

_Envdiffopdomain := [Dx,x]:

# Here xDx represents x*Dx

L1 :=-2*x^20*xDx^100 - 20*x^20*xDx^99 - 2*x^20*xDx^98 - 540*x^20*xDx^96 - x^20*xDx^95 - 3*x^20*xDx^94 + x^20*xDx^93 - x^20*xDx^92 - 2*x^20*xDx^91 - 69*x^20*xDx^90 - x^20*xDx^89 + x^20*xDx^88 - x^20*xDx^87 - x^20*xDx^86 + 57*x^20*xDx^85 + x^20*xDx^84 - 2*x^20*xDx^83 + x^20*xDx^82 + 4*x^20*xDx^81 + 6*x^20*xDx^80 + 3*x^20*xDx^78 + x^20*xDx^77 - x^20*xDx^75 - x^20*xDx^74 - 2*x^20*xDx^73 - x^20*xDx^71 - 10*x^20*xDx^69 - x^20*xDx^68 - 15*x^20*xDx^67 + 45*x^20*xDx^66 - 5*x^20*xDx^65 + x^20*xDx^64 + x^20*xDx^62 - x^20*xDx^61 - 5*x^20*xDx^60 + x^20*xDx^59 - x^20*xDx^58 + 2*x^20*xDx^57 - x^20*xDx^56 - x^20*xDx^55 - 22*x^20*xDx^54 + 7*x^20*xDx^53 + x^20*xDx^52 - 5*x^20*xDx^51 - 14*x^20*xDx^50 - x^20*xDx^48 - 4*x^20*xDx^47 - x^20*xDx^46 + x^20*xDx^45 + x^20*xDx^44 + 413*x^20*xDx^43 - x^20*xDx^42 - x^20*xDx^41 - x^20*xDx^40 + x^20*xDx^39 + 12*x^20*xDx^38 + x^20*xDx^35 - 4*x^20*xDx^34 - 2*x^20*xDx^33 - 2*x^20*xDx^31 - x^20*xDx^30 - 2*x^20*xDx^29 + x^20*xDx^28 - x^20*xDx^27 + 2*x^20*xDx^26 - x^20*xDx^24 + 2*x^20*xDx^23 + x^20*xDx^21 - 3*x^20*xDx^20 + x^20*xDx^19 - x^20*xDx^18 + 3*x^20*xDx^16 + x^20*xDx^15 - 3*x^20*xDx^13 - 21*x^20*xDx^12 - 2*x^20*xDx^10 + x^20*xDx^9 + x^20*xDx^8 - 8*x^20*xDx^7 + 2*x^20*xDx^6 - 6*x^20*xDx^5 + 5*x^20*xDx^4 - 3*x^20*xDx^3 + 11*x^20*xDx^2 - 2*x^20*xDx + 8*x^20;

L2 :=-4*x^20*xDx^100 + x^20*xDx^99 - x^20*xDx^98 + 3*x^20*xDx^97 + 5*x^20*xDx^95 - 74*x^20*xDx^94 + x^20*xDx^93 - 2*x^20*xDx^92 - 23*x^20*xDx^91 + x^20*xDx^88 - x^20*xDx^86 + 3*x^20*xDx^85 - x^20*xDx^84 - 6*x^20*xDx^82 - 5*x^20*xDx^81 + 48*x^20*xDx^80 - x^20*xDx^78 + 8*x^20*xDx^77 - x^20*xDx^76 + x^20*xDx^75 + x^20*xDx^74 + 2*x^20*xDx^72 + x^20*xDx^71 - x^20*xDx^70 - x^20*xDx^69 + 2*x^20*xDx^68 - x^20*xDx^67 + 2*x^20*xDx^66 - x^20*xDx^65 - 4*x^20*xDx^64 - x^20*xDx^63 - x^20*xDx^62 + x^20*xDx^61 - x^20*xDx^60 - x^20*xDx^58 - x^20*xDx^57 - x^20*xDx^56 - 2*x^20*xDx^55 - 16*x^20*xDx^54 - x^20*xDx^51 + x^20*xDx^50 - x^20*xDx^47 + 8*x^20*xDx^46 + x^20*xDx^44 + 9*x^20*xDx^43 - 3*x^20*xDx^41 + 45*x^20*xDx^40 - x^20*xDx^39 - x^20*xDx^38 - x^20*xDx^37 - x^20*xDx^35 - x^20*xDx^34 - x^20*xDx^33 - 2*x^20*xDx^32 + 3*x^20*xDx^31 + x^20*xDx^30 - x^20*xDx^29 + 3*x^20*xDx^28 + 2*x^20*xDx^26 + x^20*xDx^25 - 6*x^20*xDx^24 - 79*x^20*xDx^23 + 3*x^20*xDx^22 + 2*x^20*xDx^21 + x^20*xDx^20 - 4*x^20*xDx^18 - x^20*xDx^17 + 55*x^20*xDx^16 + x^20*xDx^14 + 4*x^20*xDx^13 - 4*x^20*xDx^12 + 4*x^20*xDx^11 - 4*x^20*xDx^10 - 2*x^20*xDx^8 + 11*x^20*xDx^7 - x^20*xDx^5 + x^20*xDx^4 + x^20*xDx^3 - 2*x^20*xDx^2 - 2*x^20*xDx - x^20;

L1_Dx_notation := add( coeff(L1,xDx,i) * mult( (x*Dx)$i ), i = 0..degree(L1, xDx)):
L2_Dx_notation := add( coeff(L2,xDx,i) * mult( (x*Dx)$i ), i = 0..degree(L1, xDx)):
L1L2 := mult(L1_Dx_notation,L2_Dx_notation);

#Start_Time := time();

Linput := Wrapper(l_p, [L1L2,0]);
V := Wrapper(factor_op, [Linput, `all right factors`]);
# Now V contains a list of right-hand factors in Q[[x]][xDx]
# stored in an internal format.  We need another program to read off terms.

Try1 := Wrapper(nt, [ V[1], 3] );
Try2 := Wrapper(nt, [ V[2], 3] );

# One of these Try's has large coefficients,  while the other gives the
# right-hand factor L2 reduced mod x^3.
# Lets compute some more terms for that one.

if length(Try1) < length(Try2) then
	R := Wrapper(nt, [ V[1], 21] )
else
	R := Wrapper(nt, [ V[2], 21] )
fi;

normal(L2/R);

# As you can see,  Maple's internal factor_op command (combined with nt)
# factored the operator L in half a second.

# In the rational Weyl algebra, factoring this operator of order 20 would
# have been quite time consuming.  But in the polynomial Weyl algebra,
# factoring is generally much faster.  Of course, this is just one example,
# one could consider different types of examples, but when comparing
# algorithms on examples and CPU times, one could include this example.

#time() - Start_Time;
