with(DETools):
Wrapper := proc(P, A)
	global x, Dx, xDx, `DEtools/diffop/x`,`DEtools/diffop/DF`, `DEtools/diffop/xDF`;
	local R;
	R := eval(A, {x=`DEtools/diffop/x`, Dx=`DEtools/diffop/DF`, xDx=`DEtools/diffop/xDF`});
	R := P(op(R));
	eval(R, {`DEtools/diffop/x` = x,`DEtools/diffop/DF` = Dx, `DEtools/diffop/xDF` = xDx})
end:

macro(
	eval_laurent=`DEtools/diffop/eval_laurent`,
	nt=`DEtools/diffop/nt`,
	factor_op=`DEtools/diffop/factor_op`,
	l_p=`DEtools/diffop/l_p`
):

_Envdiffopdomain := [Dx,x]:

# Here xDx represents x*Dx

L1 :=-2*xDx^125 - 2*xDx^124 + 5*xDx^123 - xDx^122 + 3*xDx^121 + xDx^119 + xDx^118 + 3*xDx^117 + xDx^116 - 3*xDx^115 - xDx^114 - 3*xDx^113 - xDx^112 - xDx^111 + xDx^110 + 2*xDx^109 + 2*xDx^108 - 4*xDx^107 + 2*xDx^105 + xDx^104 - xDx^103 + 2*xDx^101 + 26*xDx^100 - 7*xDx^99 + xDx^98 + xDx^97 + 2*xDx^96 - xDx^94 + xDx^93 - xDx^92 + xDx^91 - xDx^90 + 11*xDx^89 - xDx^88 + 4*xDx^87 - xDx^85 + 6*xDx^84 - xDx^83 - 5*xDx^82 - xDx^81 + xDx^80 - 13*xDx^79 - xDx^78 + 4*xDx^76 - xDx^75 - xDx^74 + xDx^72 - 9*xDx^70 + xDx^69 + xDx^67 + 5*xDx^66 + xDx^65 - 2*xDx^64 + xDx^63 + xDx^61 - xDx^59 + 10*xDx^58 + 2*xDx^56 + xDx^55 + xDx^54 - 6*xDx^53 + xDx^52 - 2*xDx^50 - 3*xDx^49 + xDx^47 - xDx^46 + 2*xDx^45 + 2*xDx^43 - xDx^42 - xDx^41 + xDx^40 - 4*xDx^39 - 3*xDx^37 + 5*xDx^36 + 8*xDx^33 + 6*xDx^32 - xDx^31 - xDx^29 - xDx^26 - xDx^24 + 2*xDx^23 - 2*xDx^22 - xDx^19 - xDx^18 + xDx^17 - 2*xDx^16 + xDx^14 + 9*xDx^13 - 10*xDx^12 - 88*xDx^11 + xDx^9 + xDx^8 + 3*xDx^7 + xDx^6 + xDx^5 + xDx^4 - xDx^3 - 9*xDx^2 + xDx + 4;

L2 :=-xDx^125 + xDx^124 + xDx^123 - xDx^122 + xDx^121 + xDx^120 - xDx^119 - 2*xDx^118 + 6*xDx^117 - xDx^116 + xDx^115 - 5*xDx^114 - xDx^113 + 4*xDx^112 - 2*xDx^111 + xDx^110 + 2*xDx^108 - xDx^107 - 2*xDx^104 + xDx^103 - 4*xDx^102 + xDx^101 - 2*xDx^100 - 8*xDx^99 + 4*xDx^98 + xDx^97 + xDx^96 + 4*xDx^95 - xDx^94 + xDx^93 + xDx^92 - xDx^91 - xDx^90 - 4*xDx^88 - 3*xDx^87 + 4*xDx^85 - 2444*xDx^83 - xDx^80 - 11*xDx^79 + xDx^76 - 6*xDx^75 + xDx^74 + xDx^72 + xDx^71 - xDx^69 + xDx^67 - 3*xDx^66 + 2*xDx^65 - xDx^64 + xDx^63 - xDx^59 - xDx^57 - 3*xDx^56 - 2*xDx^55 + xDx^54 - 6*xDx^53 + 2*xDx^50 + 2*xDx^49 - xDx^48 - 17*xDx^47 - xDx^45 - 6*xDx^44 + xDx^42 + 2*xDx^41 + xDx^40 - 4*xDx^39 - 8*xDx^37 - xDx^34 - xDx^33 - 2*xDx^32 + 9*xDx^31 - 3*xDx^30 - xDx^29 + xDx^28 + 3*xDx^27 - 4*xDx^26 + 2*xDx^25 + xDx^24 - 3*xDx^23 - 20*xDx^22 - xDx^21 + 50*xDx^20 + xDx^19 + 2*xDx^18 - 2*xDx^17 + 21*xDx^16 - 4*xDx^15 - 10*xDx^14 + 38*xDx^13 - xDx^12 - xDx^11 + xDx^10 - xDx^8 - xDx^7 - 13*xDx^6 - 55*xDx^5 + xDx^3 - 4*xDx^2 + xDx + 1;

L1_Dx_notation := add( coeff(L1,xDx,i) * mult( (x*Dx)$i ), i = 0..degree(L1, xDx)):
L2_Dx_notation := add( coeff(L2,xDx,i) * mult( (x*Dx)$i ), i = 0..degree(L1, xDx)):
L1L2 := mult(L1_Dx_notation,L2_Dx_notation);

#Start_Time := time();

Linput := Wrapper(l_p, [L1L2,0]);
V := Wrapper(factor_op, [Linput, `all right factors`]);
# Now V contains a list of right-hand factors in Q[[x]][xDx]
# stored in an internal format.  We need another program to read off terms.

Try1 := Wrapper(nt, [ V[1], 3] );
Try2 := Wrapper(nt, [ V[2], 3] );

# One of these Try's has large coefficients,  while the other gives the
# right-hand factor L2 reduced mod x^3.
# Lets compute some more terms for that one.

if length(Try1) < length(Try2) then
	R := Wrapper(nt, [ V[1], 21] )
else
	R := Wrapper(nt, [ V[2], 21] )
fi;

normal(L2/R);

# As you can see,  Maple's internal factor_op command (combined with nt)
# factored the operator L in half a second.

# In the rational Weyl algebra, factoring this operator of order 20 would
# have been quite time consuming.  But in the polynomial Weyl algebra,
# factoring is generally much faster.  Of course, this is just one example,
# one could consider different types of examples, but when comparing
# algorithms on examples and CPU times, one could include this example.

#time() - Start_Time;
